// Generated by CoffeeScript 2.5.1
(function() {
  jQuery.fn.reverse = [].reverse;

  window.utilities = {
    
    // Set up AJAX for orderable tables
    //       table needs class 'orderable'
    //       button to save order has id 'aspectsSaveOrder'
    //       data saved to same URL using postListOrder function above

    setUpSortable: function() {
      console.log("Fragmenty.setUpSortable run");
      
      // Keep table columns same width while element dragged 
      $("table.orderable thead tr:last-child th").each(function() {
        var w;
        w = $(this).width() + 1;
        $(this).css({
          width: w + "px"
        });
      });
      $("table.orderable tbody").sortable({
        placeholder: "sortable-placeholder",
        forcePlaceholderSize: true,
        cursor: "move",
        scroll: true,
        update: function(event, ui) {
          var content, table;
          table = $(ui.item).closest("tbody");
          content = $(table).find("span.record_id").text();
          $("input[name=\"order\"]").val(content);
        }
      });
      $("ul.orderable").sortable({
        placeholder: "sortable-placeholder",
        forcePlaceholderSize: true,
        cursor: "move",
        scroll: true,
        update: function(event, ui) {
          var content, list;
          list = $(ui.item).closest("ul");
          content = $(list).find("span.record_id").text();
          $("input[name=\"order\"]").val(content);
        }
      });
    }
  };

  window.Fragmenty = (function() {
    class Fragmenty {
      constructor(opt1) {
        this.showTop = this.showTop.bind(this);
        this.showBottom = this.showBottom.bind(this);
        this.initContent = this.initContent.bind(this);
        this.update = this.update.bind(this);
        this.TUError = this.TUError.bind(this);
        this.pushState = this.pushState.bind(this);
        this.taskUpdate = this.taskUpdate.bind(this);
        this.navigate = this.navigate.bind(this);
        this.link = this.link.bind(this);
        this.actionLink = this.actionLink.bind(this);
        this.openLink = this.openLink.bind(this);
        this.load = this.load.bind(this);
        this.showActive = this.showActive.bind(this);
        this.post = this.post.bind(this);
        this.post_form = this.post_form.bind(this);
        this.pseudoForm = this.pseudoForm.bind(this);
        this.modify = this.modify.bind(this);
        this.append = this.append.bind(this);
        this.activateOverlay = this.activateOverlay.bind(this);
        this.nextAction = this.nextAction.bind(this);
        this.popupClose = this.popupClose.bind(this);
        this.overlayClose = this.overlayClose.bind(this);
        this.opt = opt1;
        this._opt = { // set default values
          // instance variables (ref using @_opt.variable_name
          debug: 0, // 0 = no debuggin info, 1 = some debugging info
          popupId: 'popup', // id of element for popup content
          activeLinkClass: 'is-active', // class to assign to any link that is considered 'active' (relates to current content)
          handleAllLinks: false, // Fragmenty handles all links preventing default action only on those within sitePath
          pushState: true, // does this code handle pushing the new state (location) to browser history?
          rePushTest: /.*/, // capture the url path needed to compare and decide whether to push state
          sitePath: null, // URL must begin with this to handle using Fragmenty
          popupHeightClearance: 160, // Used to specify how much space left above and below popup 'window'
          pushstate_on_update: true, // push new state to browser history only if content updated on load
          tasks: [], // list of task ids for recurring status updates
          taskid_prefix: 'task_output_', // prefix to task update element id
          injectFunction: null // optional javascript function to inject content into element instead of replaceing content
        };
        $.extend(true, this._opt, this.opt); // overwrite defaults with those provided
        this.init();
      }

      init(opt) {
        var href, match, path, query, site, urlParams;
        // handle navigation tree actions, incl. links
        // stop IE 11 touch events triggering page navigation
        // (for some reason preventDefault doesn't stop link navigation)

        //@_opt.debug > 0 and console.log("Fragmenty.init : ", this);
        this.currHref = window.location.href;
        if (this._opt.sitePath.startsWith('/')) {
          match = window.location.href.trim().match(/^((http[s]?|ftp):\/\/)?\/?([^\/\s]+)/i);
          site = match[1] + match[3];
          this._opt.debug > 0 && console.log("Fragmenty.init site: " + site);
          this._opt.sitePath = site + this._opt.sitePath; // make sitePath parameter a complete URI e.g. http://mysite.domain:80/
          this._opt.debug > 0 && console.log("Fragmenty.init updated sitePath: " + this._opt.sitePath);
        }
        
        // init content loading links for whole page
        this.initContent($('body'));
        
        // Return to top of scrollable element when content refreshed
        $(document.body).on('DOMSubtreeModified', '.fr-toprefresh', this.showTop);
        //$(document.body).on 'DOMSubtreeModified', '.fr-scrollbottom', @showBottom

        // universal popup/overlay close icon action
        //$(document.body).on "click touchend pointerup",".jn_close",@popupClose
        $(document.body).on("click", ".fr-close", this.popupClose);
        if (this._opt.handleAllLinks) {
          this._opt.debug > 0 && console.log("Fragmenty.init handling all links in page");
          // intercept all links
          // TODO: Add touch screen capability here if needed
          $(document.body).on("click", "a", this.link);
        } else {
          this._opt.debug > 0 && console.log("Fragmenty.init handling explicitly defined fragment links in page");
          // intercept fragmenty action links (these don't change browser address)
          // TODO: Add touch screen capability here if needed (touchend or pointerup events)
          $(document.body).on("click", "a.fr-action", this.actionLink);
          // intercept other explicit fragmenty links
          $(document.body).on("click", "a.fr-link", this.openLink);
        }
        
        // experimental pseudoForm feature
        $(document.body).on("click", ".fr-pseudoform-parent .fr-pseudoform", this.pseudoForm);
        
        // intercept submits in new content
        $(document.body).on("click", "form input[type=submit]", this.post);
        
        // will need to be separate from tree nav stuff if more than one treenav used
        $(window).on('popstate', this.navigate);
        path = window.location.pathname;
        href = window.location.href;
        query = window.location.search;
        
        // This section caters for path not fully matching main path and loads
        // the full master path on first load, this prevents some funny behaviour
        // such as reloading whole page into content pane
        //@_opt.debug > 0 and console.log("Fragmenty.init href: " + href)
        //@_opt.debug > 0 and console.log("Fragmenty.init sitePath: " + @_opt.sitePath)
        //@_opt.debug > 0 and console.log("Fragmenty.init difference: " + (href.length - @_opt.sitePath.length))
        if (href.startsWith(this._opt.sitePath)) {
          this._opt.debug > 0 && console.log("Fragmenty.init in managed site.");
          urlParams = new URLSearchParams(window.location.search);
          if (urlParams.has('fragoto')) {
            this._opt.debug > 0 && console.log("Fragmenty.init fragoto parameter specified, loading new location.");
            //currUrl = location.href.replace(/https?:\/\/[^\/]+/i, "") # browser relative url
            this.load(urlParams.get('fragoto'), null); // load content specified by path
            history.replaceState(null, "", urlParams.get('fragoto')); // replace address in browser history, forgetting the fragoto query
          } else {
            $('.fr-hidden').removeClass('fr-hidden');
          }
        }
        this._opt.debug > 0 && console.log("register Esc to close");
        $("body").on("keyup.popupClose", (e) => {
          // 27 == "esc"
          this._opt.debug > 1 && console.log("keyup");
          if (e.which === 27) {
            // close popup if Esc key pressed
            e.preventDefault();
            return this.esc(); //@popupClose  # without event then close all open popups
          }
        });
        this._opt.debug > 0 && console.log("Fragmenty.init : " + path);
        return this.showActive();
      }

      esc() {
        var res;
        this._opt.debug > 1 && console.log("Fragmenty.esc");
        res = this.revertTempSwap();
        this._opt.debug > 1 && console.log("Fragmenty.esc revertTempSwap result ", res);
        if (!res) {
          return this.popupClose();
        }
      }

      showTop(e) {
        var el;
        // Make sure we are at the top of scrollable container when content updated
        this._opt.debug > 0 && console.log("Fragmenty.showTop");
        el = e.target;
        return setTimeout(function() {
          return $(el).closest(".fr-toprefresh").scrollTop(0);
        }, 5);
      }

      showBottom(e) {
        // Make sure we are at the top of scrollable container when content updated
        this._opt.debug > 0 && console.log("Fragmenty.showTop");
        return setTimeout(function() {
          var el, goto;
          el = $(e.target).closest(".fr-scrollbottom");
          goto = $(el).scrollToMax();
          return el.scrollTop(goto);
        }, 5);
      }

      initContent(element) {
        var first_focus, first_input;
        // Initialise part of page that has been loaded
        // register actions for form submits, action links, and normal links
        // checks for task_updater element and kicks off update checks
        //if window.smartforms
        //    smartforms.init(element)
        this._opt.debug > 0 && console.log("Fragmenty.initContent " + $(element).attr('class'));
        if (element instanceof HTMLElement || element.length) { // an element or jquery result set >= 1
          
          // stop IE 11 touch events triggering page navigation
          // (for some reason preventDefault doesn't stop link navigation)
          //$(element).find("a").css("touch-action","none")
          first_focus = $(element).find('.fr-focus:input:enabled:visible');
          if (first_focus != null) {
            this._opt.debug > 1 && console.log("Fragmenty.initContent focus explicitly requested on ", first_focus);
            first_focus.removeClass("fr-focus").focus();
          } else {
            first_input = $(element).find(':input:enabled:visible:first');
            this._opt.debug > 1 && console.log("Fragmenty.initContent set focus on first suitable input ", first_input);
            first_input.focus();
          }
          $(element).find('.fr-taskupdater').each((i, tu) => {
            var tuid;
            tuid = $(tu).data('taskid');
            this._opt.debug > 0 && console.log("Fragmenty.initContent tuid: " + tuid);
            $(tu).attr('data-count', 3600); // set timeout count
            return this._opt.tasks.push(tuid);
          });
          return this.update(); // begin update process
        }
      }

      update() {
        var done, href, line, results, tid, to;
        // send update request to server to get updated output for task 
        this._opt.debug > 0 && console.log("Fragmenty.update tasks: " + this._opt.tasks);
        results = [];
        while (this._opt.tasks.length) {
          tid = this._opt.tasks.shift(); // take first item from list
          this._opt.debug > 1 && console.log("Fragmenty.update: id " + this._opt.taskid_prefix + tid);
          to = $('#' + this._opt.taskid_prefix + tid);
          this._opt.debug > 1 && console.log("Fragmenty.update found: " + to.length);
          if (to.length) { // check relevant output element still exists
            to = $('#' + this._opt.taskid_prefix + tid).first();
            href = to.attr('data-href');
            line = to.attr('data-line');
            href = href + '?line=' + line;
            this._opt.debug > 1 && console.log("Updater href: " + href);
            done = to.attr('data-done');
            $(document).css('cursor', 'wait');
            results.push($.ajax({
              url: href,
              type: 'POST',
              dataType: 'json',
              success: this.taskUpdate,
              error: () => {
                return this.TUError(tid);
              },
              timeout: 5000 // 5 second timeout
            }));
          } else {
            results.push(void 0);
          }
        }
        return results;
      }

      TUError(task_id) {
        var done, text, timeoutID, to;
        // Elegantly handle failed calls to a task update page on the server
        // this was originally in place to handle task updates for tasks that will
        // interrupt web service, such as nginx restart requests.
        this._opt.debug > 0 && console.log("Fragmenty.TUError: task update call failed.");
        to = $('#' + this._opt.taskid_prefix + task_id);
        done = false; // assume not done
        text = to.html(); // existing content of task output element
        text = text + "."; // add dot for each failed request
        to.html(text); // reload full task output text
        
        // keep checking for updates
        this._opt.tasks.push(task_id); // add back to the list
        timeoutID = window.setTimeout(this.update, 500); // return without any data
      }

      pushState(newHref) {
        // Update our browser history and track Href of last loaded content
        // This should be called after new content has been loaded and record the new Href
        this._opt.debug > 1 && console.log("Fragmenty.pushState newHref = " + newHref);
        this.currHref = newHref; // keep our record of currently loaded page up to date
        history.pushState(null, "", newHref); // add to browser history
      }

      taskUpdate(data, status, xhr) {
        var count, done, donePattern, doneRegExp, i, newline, req_cmd, request, sPane, subpane, text, timeoutID, to;
        // Handle returned content from task update request

        // data has these attributes
        // - taskid  (taskid)
        // - output  (array of text lines)
        // - line  (how many lines read from state so far)
        // - done (boolean - whether task completed or not)
        // - donepattern (regex to regognise line that indicates task is done)
        to = $('#' + this._opt.taskid_prefix + data['taskid']);
        request = '';
        donePattern = to.attr('data-donepattern');
        if (donePattern) {
          doneRegExp = new RegExp(donePattern);
        }
        done = false; // assume not done
        text = to.html(); // existing content of task output element
        this._opt.debug > 1 && console.log("Fragmenty.taskUpdate current text: " + text);
        if (text.trim().length > 0) {
          newline = "\n";
          this._opt.debug > 1 && console.log("Fragmenty.taskUpdate we already have text, setting newline ");
        } else {
          newline = "";
          this._opt.debug > 1 && console.log("Fragmenty.taskUpdate no text yet, no newline set");
        }
        req_cmd = 'fragmenty_request: ';
        this._opt.debug > 1 && console.log("Fragmenty.taskUpdate processing output " + data['output']);
        while (data['output'].length > 0) {
          i = data['output'].shift(); // pop first item of remain output 
          
          // look for any request commands in output
          if (i.startsWith(req_cmd)) {
            request = i.replace(req_cmd, '').trim();
            this._opt.debug > 0 && console.log("Fragmenty.taskUpdate found request " + request + " in " + i);
          
          // look for indicate that task is done
          } else if (donePattern && i.match(doneRegExp)) {
            this._opt.debug > 1 && console.log("Fragmenty.taskUpdate found done pattern in " + i);
            done = true;
            text = text + newline + "Task Done.";
            newline = "\n";
            continue; // otherwise add line to output
          } else {
            this._opt.debug > 1 && console.log("Fragmenty.taskUpdate adding '" + newline + i + "' to output");
            text = text + newline + i;
            newline = "\n";
          }
        }
        if (!done) { // not already recognised done using donePattern
          done = data['done'];
        }
        this._opt.debug > 1 && console.log('Fragmenty.taskUpdate new update text: ' + text);
        to.html(text); // reload full task output text
        to.attr('data-line', data['line'].toString()); // store details of lines returned so far
        to.attr('data-done', done.toString()); // store status (done or not)
        
        // count down from original count value and record as done if we get to zero
        // precaution against tasks running excessivley long
        count = to.attr('data-count');
        count = count - 1;
        to.attr('data-count', count);
        if (count <= 0) {
          done = true;
        }
        
        // auto scroll down on .visible element as content added
        sPane = $(to).closest('.fr-scroll');
        if (sPane.length > 0) {
          $(sPane).scrollTop($(sPane)[0].scrollHeight);
          this._opt.debug > 1 && console.log("Fragmenty.taskUpdate adjusting scrollHeight: " + $(sPane)[0].scrollHeight);
        }
        this._opt.debug > 0 && console.log("task done status: " + done);
        
        // arrange another (delayed) call to the update request
        // only works if one task to update at a time

        // TODO adjust to handle more than one task id in tasks list
        // currently this would generate another update for each task update done
        // but each run of @update should handle all the tasks and so should
        // only be handled once, for all tasks, not once for each tasks as 
        // this code does at the moment.
        if (done) {
          // check if follow on action defined within this subpane and act on it
          subpane = $(to).closest('.fr-content');
          this._opt.debug > 0 && console.log("Fragmenty taskUpdate: task done, looking for next action in this content");
          this.nextAction(subpane);
        } else {
          // keep checking for updates
          this._opt.tasks.push(data['taskid']);
          timeoutID = window.setTimeout(this.update, 500);
        }
        if (request) {
          this._opt.debug > 0 && console.log("Fragmenty.taskUpdate: making request " + request + " using load method");
          this.load(request, null); // make a http request, don't change browser address
        }
      }

      navigate(e) {
        var link;
        // Handle change due to browser navigation buttons (forward and back)
        // TODO Handle navigation involving # hashes (doesn't navigate within document currently)
        link = location.href;
        this._opt.debug > 0 && console.log("Fragmenty.navigate new location: " + link);
        this._opt.debug > 0 && console.log("Fragmenty.navigate sitePath: " + this._opt.sitePath);
        
        // Check if still within the 'master' area we are responsible for
        if (link.startsWith(this._opt.sitePath)) {
          this.popupClose(); // close popup/dialog elements before navigating elsewhere
          this.load(link, null);
          return e.originalEvent.preventDefault(); // Prevent default back action if we have handled it here
        } else {
          return this._opt.debug > 0 && console.log("Fragmenty.navigate outside our site, ignoring");
        }
      }

      link(e) {
        var el, href, sitePath;
        // universal link handler, determines what action to take or whether to allow default action
        this._opt.debug > 0 && console.log("Fragmenty.link triggered");
        el = e.target;
        if (!$(el).is('a')) {
          el = $(el).closest('a');
        }
        href = $(el).prop('href'); //.replace(/https?:\/\/[^\/]+/i, "") # link relative url
        if (/https?:\/\/[^\/]+/i.test(href)) { // no scheme and server address
          sitePath = this._opt.sitePath;
        } else {
          this._opt.debug > 1 && console.log("Fragmenty.link href is on same server");
          sitePath = this._opt.sitePath.replace(/https?:\/\/[^\/]+/i, ""); // strip scheme and address off sitePath for comparison
        }
        this._opt.debug > 1 && console.log("Fragmenty.link href: " + href + " sitePath: " + sitePath);
        if (href.startsWith(sitePath)) { // within Fragmenty managed site
          this._opt.debug > 1 && console.log("Fragmenty.link within Fragmenty site: " + sitePath);
          if ($(el).hasClass('fr-action')) {
            return this.actionLink(e);
          } else {
            return this.openLink(e);
          }
        } else {

        }
      }

      actionLink(e) {
        var a, action, c, href, item, method;
        // Handle a link that performs action within the content panes context
        // e.g. not moving to other content, but adding content below this or as popup
        // doesn't change browser path like openLink, allows double check before continue
        this._opt.debug > 0 && console.log("Fragmenty.actionLink " + e.type);
        a = e.target;
        if (!$(a).is('a')) {
          a = $(a).closest('a');
        }
        e.preventDefault();
        if (e.type !== "click" && e.type !== "touchend") {
          this._opt.debug > 1 && console.log("Fragmenty.actionLink type=" + e.type + "abandoned"); // ignore touch events
          return;
        }
        href = $(a).attr('href');
        this._opt.debug > 1 && console.log("Fragmenty.actionLink link ", href);
        if (href && href.length > 0 && href.startsWith("#")) {
          this._opt.debug > 1 && console.log("Fragmenty.actionLink in page navigation to " + href);
          $(href)[0].scrollIntoView();
          return;
        }
        if ($(a).hasClass('double_check')) {
          item = $(a).closest('.fr-actionitem').addClass('selected');
          c = confirm($(a).text() + "?");
          $(item).removeClass('selected');
        } else {
          c = true;
        }
        if (c) {
          //href = $(a).attr("href")
          $('body').addClass('wait');
          if ($(a).hasClass('post')) {
            this._opt.debug > 0 && console.log("Fragmenty.actionLink using POST");
            action = $(a).data('action');
            method = 'POST';
          } else {
            method = 'GET';
            action = '';
          }
          $.ajax({
            type: method,
            url: href,
            data: action,
            success: this.append
          });
          this._opt.debug > 0 && console.log("Fragmenty.actionLink done");
        } else {
          this._opt.debug > 0 && console.log('Fragmenty.actionLink cancelled');
        }
      }

      openLink(e) {
        var curr, el, href;
        // Load new content into pane based on the navigation link just clicked on
        // TODO recognise links outside the 'managed' ajax pages and let the browser handle those normally

        // attempts to get IE11 to handle preventDefault properly
        if (typeof e.preventDefault === 'function') {
          this._opt.debug > 0 && console.log("Fragmenty.openLink event has preventDefault");
        }
        if (!e) {
          this._opt.debug > 0 && console.log("Fragmenty.openLink event not found, using window event");
          e = window.event;
        }
        e.preventDefault();
        el = e.target;
        
        // make sure we are looking at anchor not child element
        if (!$(el).is('a')) {
          el = $(el).closest('a');
        }
        href = $(el).attr("href").replace(/https?:\/\/[^\/]+/i, ""); // link relative url
        curr = location.href.replace(/https?:\/\/[^\/]+/i, ""); // browser relative url
        this.load(href, curr);
        return false;
      }

      load(newHref, currHref) {
        var loadHref;
        // load content for newHref
        // newHref and currHref should not include protocol, host, or port part or URL
        // if load is triggered by browser navigation (back and forward) then currRef = null
        // push state should not be triggered if currRef = null
        this._opt.debug > 0 && console.log("Fragmenty.load going to component: " + newHref);
        if (!newHref) {
          // use current browser location path if newHref not specified
          this._opt.debug > 0 && console.log("Fragmenty load: no newHref supplied taking browsers location path");
          newHref = window.location.pathname;
        }
        // new way URLs called as normal, web server application chooses to deliver fragments
        loadHref = newHref;
        
        // use object's record of current Href if currHref not provided
        //if (currHref == null)
        //    currHref = @currHref
        $('body').addClass('wait');
        
        // Make request for new content
        this._opt.debug > 1 && console.log("Fragmenty.load request to " + loadHref);
        return $.ajax({
          type: 'GET',
          headers: {
            "X-Fragmenty": "load"
          },
          url: loadHref
        }).done((content, status, xhr) => {
          var cmpCurr, cmpNew, cmpRef, updates;
          this._opt.debug > 1 && console.log("Fragmenty.load content load done");
          updates = this.append(content, status, xhr);
          
          // if url is different then push new state into browser history
          if (currHref !== null) {
            cmpCurr = currHref.match(this._opt.rePushTest)[0];
          } else {
            cmpRef = null;
          }
          cmpNew = newHref.match(this._opt.rePushTest)[0];
          this._opt.debug > 1 && console.log("Fragmenty.load cmpCurr=" + cmpCurr);
          this._opt.debug > 1 && console.log("Fragmenty.load cmpNew=" + cmpNew);
          
          // Update browser state if we weren't going back/forward (currHref=null) and
          // loaded page actually updated the contents of this page (updates > 0)
          if (this._opt.pushState && (currHref !== null) && (cmpCurr !== cmpNew)) { // if different to current URL
            if (this._opt.pushstate_on_update) { // Check if option for push state to depend on updated content is on
              if (updates > 0) { // some updates made
                this._opt.debug > 0 && console.log("Fragmenty.load: pushing new state to browser history");
                this.pushState(newHref); // push state (and any other associated actions)
              } else {
                //history.pushState(null,"", newHref)  # add to browser history
                this._opt.debug > 0 && console.log("Fragmenty.load: no updates, no new browser history state"); // pushstate anyway regardless of whether updated content or not
              }
            } else {
              this._opt.debug > 0 && console.log("Fragmenty.load: pushing new state to browser history");
              this.pushState(newHref); // push state (and any other associated actions)
            }
          } else {
            //history.pushState(null,"", newHref)  # add to browser history                        
            this._opt.debug > 0 && console.log("Fragmenty.load no change of location");
          }
          if (updates > 0) {
            this.showActive(); // update links to indicate current active link
            // trigger any other libraries listening for Fragmenty page load events
            $(window).trigger("fragmenty:load");
            return this._opt.debug > 1 && console.log("Fragmenty.load triggered fragmenty:load event");
          }
        }).fail(() => {
          return this._opt.debug > 1 && console.log("Fragmenty.load content load failed");
        });
      }

      showActive() {
        var link, relative, sections;
        // current content to help users see where they are in the site.
        this._opt.debug > 0 && console.log("Fragmenty.showActive");
        link = location.href;
        // work out location (within site) without # or ? paramters to ensure a good match with anchor links
        relative = location.href.replace(location.origin, '').replace(location.hash, '').replace(location.search, '');
        this._opt.debug > 1 && console.log("Fragmenty.showActive relative: " + relative);
        $('.fr-linkitem a').not('[href="' + relative + '"]').closest(".fr-linkitem").removeClass(this._opt.activeLinkClass);
        $('.fr-linkitem a[href="' + relative + '"]').closest(".fr-linkitem").addClass(this._opt.activeLinkClass);
        //$('a[href$="' + relative + '"]').closest("li").addClass("is-active").siblings().removeClass("is-active")

        // handle sections (fr-section) where only part of the path may match indicating it is in this section
        sections = $('.fr-section a');
        return $(sections).each((i, el) => {
          var href;
          href = $(el).attr("href").replace('index.html', '');
          this._opt.debug > 1 && console.log("Fragmenty.showActive checking section " + href);
          if (relative.startsWith(href)) {
            this._opt.debug > 1 && console.log("Fragmenty.showActive matches section " + href);
            return $(el).closest(".fr-section").addClass(this._opt.activeLinkClass);
          }
        });
      }

      post(e) {
        var bname, button, bvalue, c, curr, form, item;
        // like load but post form data and then load response into new div
        // appended to main pane.
        this._opt.debug > 0 && console.log("Fragmenty.post");
        button = e.target;
        e.preventDefault();
        if (e.type !== "click" && e.type !== "touchend") {
          this._opt.debug > 0 && console.log("Fragmenty.post type=" + e.type + " abandoned"); // ignore touch events
          return;
        }
        if ($(button).hasClass('double_check')) {
          // throw up confirmation dialog
          item = $(button).closest('.fr-actionitem').addClass('selected');
          c = confirm($(button).attr("value") + "?");
          $(item).removeClass('selected');
        } else {
          // no check, continue anyway
          c = true;
        }
        if (c) {
          curr = location.href.replace(/https?:\/\/[^\/]+/i, ""); // browser relatiuve url
          form = $(button).closest('form');
          bname = $(button).attr('name');
          bvalue = $(button).attr('value');
          return this.post_form(form, bname, bvalue);
        }
      }

      post_form(form, bname, bvalue) {
        var closePopup, container, formData, formMethod, href;
        // post specified form (el), including button name (bname) and value (bvalue) in
        // the formData sent to web server
        formMethod = $(form).attr("method");
        
        // Check if we are meant to kee the popup open after form submit
        if ($(form).hasClass("fr-keep-popup")) {
          closePopup = false;
        } else {
          closePopup = true;
        }
        if (!formMethod) {
          formMethod = "POST"; // default to POST method if none specified
        } else {
          formMethod = formMethod.toUpperCase();
        }
        href = $(form).attr("action").replace(/https?:\/\/[^\/]+/i, ""); // link relative url
        formData = $(form).serialize();
        
        // include any element holding content to be treated as input
        // (used for container presenting editable html)
        this._opt.debug > 1 && console.log("Fragmenty.post looking for .form_input in form");
        
        // .form_input is the old class, fr-form-input is the preferred usage
        $(form).find('.form_input, .fr-form-input').each((i, el) => {
          var data, name;
          this._opt.debug > 1 && console.log("Fragmenty.post processing .form_input");
          name = $(el).attr("data-name");
          this._opt.debug > 1 && console.log("Fragmenty.post name=" + name);
          data = $(el).html();
          this._opt.debug > 1 && console.log("Fragmenty.post data=" + data);
          return formData = formData + '&' + encodeURIComponent(name) + '=' + encodeURIComponent(data);
        });
        
        // include clicked button name and value in form data
        // assumes name and value are already URL compliant
        // TODO make more robust and convert to url complaint text
        if (bname && bvalue) {
          formData = formData + '&' + bname + '=' + bvalue;
        }
        // close popup if form submitted from within pop up?
        // TODO stop this depending on popupId
        this._opt.debug > 1 && console.log("Fragmenty.post form: ", form, " closePopup", closePopup);
        container = $(form).closest('#' + this._opt.popupId);
        if (container.attr('id') === this._opt.popupId && closePopup) {
          this.popupClose();
        }
        $('body').addClass('wait');
        $.ajax({
          type: formMethod,
          headers: {
            "X-Fragmenty": "form"
          },
          url: href,
          data: formData,
          success: this.append
        });
      }

      pseudoForm(e) {
        var action, clicked, form, formData, href, item, obj_id;
        // Simple form data submission for a specific action on specific instance (id)
        this._opt.debug > 0 && console.log("Fragmenty.pseudoForm");
        clicked = e.target;
        e.preventDefault();
        item = $(clicked).closest('.fr-pseudoform');
        obj_id = item.data('id');
        action = item.data('action');
        form = item.parents('.fr-pseudoform-parent').children('form:first-child');
        if (form != null) {
          href = form.attr("action").replace(/https?:\/\/[^\/]+/i, ""); // link relative url
          formData = form.serialize() + "&action=" + action + "&id=" + obj_id;
          this._opt.debug > 1 && console.log("Fragmenty.pseudoForm " + href + " data: ", formData);
          $('body').addClass('wait');
          $.ajax({
            type: "post",
            headers: {
              "X-Fragmenty": "form"
            },
            url: href,
            data: formData,
            success: this.append
          });
        } else {
          this._opt.debug > 0 && console.log("Fragmenty.pseudoForm master form not found");
        }
      }

      modify(list) {
        // process AJAX response, looking for updates to data attributes
        this._opt.debug > 1 && console.log("Fragmenty.modify processing " + $(list).length + " element(s)");
        $(list).each((i, el) => {
          var attributes, dest, destId;
          this._opt.debug > 1 && console.log("Fragmenty.modify processing .fr-attribute element");
          destId = $(el).attr('id'); // get destination id
          dest = $("#" + destId);
          attributes = $(el).prop("attributes");
          return $.each(attributes, function() {
            if (this.name.startsWith('data-')) {
              return $(dest).attr(this.name, this.value);
            }
          });
        });
      }

      append(content, status, xhr) {
        var nav, next_action, rhtml, task_updater, updates;
        // Process response to AJAX request.
        this._opt.debug > 0 && console.log("Fragmenty.append processing returned content " + xhr.status);
        $('body').removeClass('wait');
        
        // place returned content into element so jquery can work on it
        rhtml = $('<div></div>').html(content);
        nav = $(rhtml).find('.navigation');
        if (nav) {
          this._opt.debug > 1 && console.log('Fragmenty.append navigation found');
          if (nav.first().data('navigation') === 'back') {
            this._opt.debug > 1 && console.log('Fragmenty.append navigation back');
            window.history.back(); // go back using browser history, then we are done.
            return;
          }
        }
        updates = 0; // begin count of update fragments at zero
        
        // Process each fr-place element in the returned content
        $(rhtml).find('.fr-content').not('.fr-content .fr-content').each((i, el) => {
          var changed, currSrc, dest, destId, dest_layout, done, lastChild, method, newSrc, smoothscroll, src_layout, temp;
          this._opt.debug > 1 && console.log("Fragmenty.append processing .fr-content element");
          
          // destination id should match that of original
          destId = $(el).attr('id'); // get destination id
          dest = $('#' + destId);
          currSrc = $(dest).attr('data-src');
          if (currSrc == null) {
            currSrc = "";
          }
          if (currSrc === 'none') {
            currSrc = "";
          }
          newSrc = $(el).attr('data-src');
          if (newSrc == null) {
            newSrc = "none"; // deliberately different from currSrc of neither specified
          }
          if (newSrc !== currSrc) {
            changed = true;
            updates += 1; // increment fragment updates counter
          } else {
            changed = false;
          }
          this._opt.debug > 1 && console.log("Fragmenty.append currSrc=" + currSrc + " newSrc=" + newSrc);
          this._opt.debug > 1 && console.log("Fragmenty.append destId=" + destId);
          // TODO: handle non-existent methods
          method = $(el).attr('data-method');
          dest_layout = $(dest).attr('data-layout');
          src_layout = $(el).attr('data-layout');
          this._opt.debug > 0 && console.log("Fragmenty.append method=" + method);
          done = false; // assume not done
          if (method === 'close') {
            // close dialog 'window' (aka overlay)
            this.overlayClose(dest);
            done = true;
          } else if (method === 'insert_after') {
            // simple insert of content after specified element
            this._opt.debug > 1 && console.log("Fragmenty.append inserting content");
            this.initContent(el);
            $(el).children().reverse().each((index, child) => {
              return dest.after(child);
            });
            dest.removeClass('fr-temp-swapped');
            done = true;
          } else if (method === 'append') {
            this._opt.debug > 0 && console.log("Fragmenty.append appending content");
            this.initContent(el); // initialise contents to be inserted
            lastChild = dest.children().last();
            dest.attr('data-src', ""); // leave data-src empty as it has been changed from whatever is was before
            $(el).children().reverse().each((index, newChild) => {
              return lastChild.after(newChild);
            });
            this.activateOverlay(dest); // Check if destination is to be overlaid onto page
            dest.removeClass('fr-temp-swapped');
            done = true;
          } else if (method === 'remove') {
            this._opt.debug > 0 && console.log("Fragmenty.append removing content");
            dest.remove();
            done = true;
          } else if (method === 'inject' && dest_layout === src_layout) {
            // new and old content layouts should match for this more
            // sophisticated insertion
            this._opt.debug > 0 && console.log("Fragmenty.append injecting content");
            this._opt.debug > 1 && console.log("Fragmenty.append injecting content using ", this._opt.injectFunction);
            
            // insert operation may fail checks (return false), mark not done if it fails
            done = this._opt.inserter.staticInsert(el, dest);
            dest.attr('data-src', newSrc);
            this.activateOverlay(dest); // Check if destination is to be overlaid onto page
            this.initContent(dest);
            dest.removeClass('fr-temp-swapped');
            done = true;
          } else if (method === 'temp_swap') {
            this._opt.debug > 0 && console.log("Fragmenty.append temporarily swapping content");
            this.revertTempSwap(); // undo last temporary swap ready for next one
            console.log("reverted");
            temp = $('#fr-temp-swap');
            $(temp).empty().html($(dest).html()); // put current contents into temp element
            $(temp).data('originalid', $(dest).attr('id'));
            dest.empty().html($(el).html()); // put new content in destination
            this.activateOverlay(dest); // Check if destination is to be overlaid onto page
            this.initContent(dest);
            dest.addClass('fr-temp-swapped');
            done = true;
          }
          if ((!done) && changed) {
            
            // if not covered (done) by above steps use this one
            this._opt.debug > 0 && console.log("Fragmenty.append replacing content");
            dest.attr('data-src', newSrc);
            if (dest.closest('.fr-scroll').hasClass("smoothscroll")) {
              smoothscroll = true;
            } else {
              smoothscroll = false;
            }
            dest.closest('.fr-scroll').removeClass("smoothscroll");
            dest.closest(".fr-scroll").scrollTop(0);
            dest.empty().html($(el).html());
            if (smoothscroll) {
              dest.closest('.fr-scroll').addClass("smoothscroll");
            }
            this.activateOverlay(dest); // Check if destination is to be overlaid onto page
            this.initContent(dest);
            return dest.removeClass('fr-temp-swapped');
          } else {
            return this._opt.debug > 1 && console.log("Fragmenty.append no action");
          }
        });
        // modify attributes of elements where response elements has fr-attribute class
        this.modify($(rhtml).find('.fr-attribute'));
        
        // handle follow up action if specified
        next_action = $(rhtml).find('.fr-nextaction').first();
        task_updater = $(rhtml).find('.fr-taskupdater').first();
        if (next_action.length && task_updater.length === 0) { // next action and no updater
          this._opt.debug > 1 && console.log("Fragmenty.append calling nextAction");
          this.nextAction(next_action);
        }
        this._opt.debug > 1 && console.log("Fragmenty.append # of updates: " + updates);
        
        // ensure newly updated content is visible
        $('.fr-hidden').removeClass('fr-hidden');
        return updates;
      }

      revertTempSwap() {
        var dest, rep_id, temp;
        this._opt.debug > 0 && console.log("Fragmenty.revertTempSwap");
        temp = $('#fr-temp-swap');
        rep_id = temp.data('originalid');
        this._opt.debug > 1 && console.log("Fragmenty.revertTempSwap rep_id: ", rep_id);
        if (typeof rep_id === 'string' && rep_id.length > 0) {
          dest = $('#' + rep_id);
          if (dest.hasClass('fr-temp-swapped')) {
            dest.empty().html($(temp).html());
            temp.data('originalid', '');
            temp.empty();
            return true; // we have swapped content back in
          } else {
            this._opt.debug > 1 && console.log("Fragmenty.revertTempSwap original content changed, not swapping back");
            // fr-temp-swapped class not there, content can't go back
            temp.data('originalid', '');
            temp.empty(); // clear temp content as it is no longer valid
            return false; // nothing swapped back
          }
        } else {
          return false; // nothing swapped back
        }
      }

      activateOverlay(el) {
        var container, content, popup_hgt;
        content = $(el).html().trim().length;
        // If element is within a hidden overlay component, then make visible and set height
        if ($(el).closest('.fr-overlay').length > 0 && content > 0) {
          // Handle update of overlay elements (popup boxes) by setting dimensions and making visible
          container = $(el).closest('.fr-overlay');
          this._opt.debug > 1 && console.log("Fragmenty.activateOverlay destination is an overlay element");
          // calculate max height based on browser window height
          popup_hgt = $(window).height() - this._opt.popupHeightClearance;
          this._opt.debug > 1 && console.log("Fragmenty.activateOverlay popup height=" + popup_hgt);
          //.css('max-height',popup_hgt)    # set max-height
          container.find('.fr-popup-content').closest(".fr-page-blocker").show(); // go to main content element // find element that 'hides' the page // show popup
          return container.find('.fr-scroll').scrollTop(0); // make sure we start at top of scrollables
        }
      }

      nextAction(el) {
        var action, dest, path;
        // Do follow up action on subpane load or task complete
        this._opt.debug > 1 && console.log("Fragmenty.nextAction start");
        if ($(el).is("[data-action]")) {
          action = $(el).data('action');
        } else {
          action = $(el).find('.fr-nextaction').data('action');
        }
        this._opt.debug > 1 && console.log("Fragmenty.nextAction action=" + action);
        if ($(el).is("[data-destination]")) {
          dest = $(el).data('destination');
        } else {
          dest = $(el).find('.fr-nextaction').data('destination');
        }
        this._opt.debug > 1 && console.log("Fragmenty.nextAction destination=" + dest);
        if (action === 'post_form') {
          this.post_form(el, "auto", "fr-nextaction");
        }
        if (action === 'reload') {
          // needs to use attr method as data method seems to get cached by jquery
          // uses href specific to specified destination if available
          // TODO allow calculation of path using browser path and data-trasnform
          path = $('#' + dest).first().attr('data-href'); //window.location.pathname
          this._opt.debug > 0 && console.log("Fragmenty nextAction reload_pane path: " + path);
          if (path) {
            // load content using specific path
            return this.load(path, null); // load content using data-href attribute 
          } else {
            // load content based on main browser URL
            return this.load(null, null);
          }
        }
      }

      popupClose(e) {
        var overlay;
        // Close the overlaying element by emptying out this element and hiding
        // it's parent element.
        this._opt.debug > 0 && console.log('Fragmenty.popupClose');
        if (e != null) {
          overlay = $(e.target).closest(".fr-overlay"); // otherwise get any visible overlay container
        } else {
          overlay = $(".fr-overlay:visible"); // get overlay containing the trigger element.
        }
        return this.overlayClose(overlay);
      }

      overlayClose(el) {
        // close the overlay element el can be an element or a jQuery query string
        this._opt.debug > 1 && console.log('Fragmenty.overlayClose running');
        
        // empty out content elements (fr-content) leaving pop-up structure in place
        return $(el).find(".fr-content").empty().attr('data-src', '').closest(".fr-page-blocker").hide(); // clear source details so any new content will be placed here and activated // hide pop-up element
      }

    };

    // class level variables (ref using @constructor.variable_name)
    Fragmenty.navs = []; // list of navigation container ids

    // keep track of URL for @navigate function, @actionLink and @load should update this
    // the address stored here will lag behind browser state changes, allowing us
    // to check where we were before the navigation event (forward or back)
    Fragmenty.currHref = '';

    return Fragmenty;

  }).call(this);

}).call(this);

//# sourceMappingURL=fragmenty.js.map
